/*
 * @Author: your name
 * @Date: 2021-07-17 09:13:42
 * @LastEditTime: 2021-09-05 11:21:23
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: \automatedtesting\src\views\spread\spreadFuncs.ts
 */
import '@grapecity/spread-sheets-resources-zh';

import GC from "@grapecity/spread-sheets"
// import * as sp from "@/typings/spread";
// import * as SPREAD from "@/typings/spread";
import { App, ComponentPublicInstance, createApp } from "vue";
// import { createSpreadApp } from "./spreadApp";
// import spreadApp from './spreadApp.vue'
import $ from "jquery";
// import { paramLists } from './publicInfos'
const paramLists = []
GC.Spread.Common.CultureManager.culture("zh-cn");

const needResetCols = [1,2,3,4];
const needJudgeCols = [1,2,3,4,10,15];
const canUseFuncArr = [
  'abs',
  'acos',
  'asin',
  'atan',
  'ceil',
  'cosh',
  'cos_',
  'deg',
  'exp',
  'floor',
  'log10',
  'log_',
  'rad',
  'sinh',
  'sin_',
  'sqrt',
  'tanh',
  'tan_',
]

function tailCallOptimize(f){ // 尾递归优化
  var value;
  var active = false;
  var accumulated = [];
  return function accumulator() {
    accumulated.push(arguments);
    if (!active) {
      active = true;
      while (accumulated.length) {
        value = f.apply(null, accumulated.shift());
      }
      active = false;
      return value;
    }
  };
}

export class SP {
  static spreadApp;
  isProgram = true;
  searchCondition;
  spread;
  SheetArea = GC.Spread.Sheets.SheetArea;
  _copyValue = '_copyValue';
  // _Sheets = GC.Spread.Sheets;
  Events = GC.Spread.Sheets.Events;
  // DataValidation: GC.Spread.Sheets.DataValidation;
  STYLE= (function () {
    const Sheets = GC.Spread.Sheets;
    function createStyle(styleObj) {
      var style = new GC.Spread.Sheets.Style();
      Object.assign(style, styleObj)
      return style;
    };
    return {
      TEXT_MIDDLE: createStyle({
        hAlign: Sheets.HorizontalAlign.center,
        vAlign: Sheets.VerticalAlign.center,
      }),
      WORD_WRAP: createStyle({
        wordWrap: true,
        labelOptions: { visibility: GC.Spread.Sheets.LabelVisibility.hidden },
        vAlign: Sheets.VerticalAlign.center,
      }),
      LOCKED: createStyle({
        locked: true,
      }),
      UNLOCKED: createStyle({
        hAlign: Sheets.HorizontalAlign.center,
        vAlign: Sheets.VerticalAlign.center,
        locked: false,
        wordWrap: true,
      }),
    }
  }());
  get activeSheet() { // 获取当前活动sheet
    return this.spread.getActiveSheet();
  };
  constructor(option) {
    this.spread = this.init(option);
    var that = this;
    this.spread.bind(GC.Spread.Sheets.Events.ClipboardChanged, function () {
      var selection = that.activeSheet.getSelections()[0];
      var result = [];
      for (var ri = 0; ri < selection.rowCount; ri++) {
        var rowValueArr = [];
        for (var ci = 0; ci < selection.colCount; ci++) {
          if (selection.col + ci < 0) {
            selection.colCount++;
            continue;
          }
          rowValueArr.push(that.activeSheet.getValue(selection.row + ri, selection.col + ci));
        }
        result.push(rowValueArr)
      }
      localStorage.setItem(that._copyValue, JSON.stringify(result));
    });
    AutoJudgeTypeCellType.selectUl = null;
    //@ts-ignore
    window.spreadInfo = this
  }

  init(option){
    var sheetCount = option.sheetCount || 4;
    var spread = new GC.Spread.Sheets.Workbook(document.getElementById(option.id), { sheetCount: sheetCount });
    spread.options.scrollbarMaxAlign = true;
    spread.options.scrollbarShowMax = true;
    spread.options.showHorizontalScrollbar = false;//隐藏横向滚动条
    spread.options.defaultDragFillType = 3;// 下拉拖拽时默认复制值
    spread.options.allowExtendPasteRange = true;
    // spread.options.allowUserDragFill = false;
    if (option.dataSource) {
      spread.fromJSON(option.dataSource);
    }
    var contextarr = ["gc.spread.hideSheet", "gc.spread.unhideSheet", "gc.spread.deleteSheet", "gc.spread.insertSheet"];
    // var menuData = spread.contextMenu.menuData;
    // menuData.forEach((e, i) => {
    //   if (e.name && contextarr.indexOf(e.name) >= 0) {
    //     menuData.splice(i, 1, {})
    //   }
    // })
    // var that = this;
    // spread.bind(this.Events.ClipboardPasted, function (event, data) {
    //   var row = data.cellRange.row, col = data.cellRange.col;
    //   if (row === undefined || col === undefined) {
    //     return;
    //   }
    //   var sheet = spread.getActiveSheet();
    //   if (sheet.hasPendingChanges(row, col)) {
    //     if (!AutoJudgeTypeCellType.isSim && (col == 0 || col == 2 || col == 3)) {
    //       that.checkKeyWordExplain(sheet, row, col, true);
    //     } 
    //     if(AutoJudgeTypeCellType.isSim && needJudgeCols.indexOf(col) > -1) {
    //       that.checkSimInstructionOrParamOrSubsys(sheet, row, col);
    //     }
    //   }
    // });
    return spread;
  }

  // createStyle(keyName, styleObj) { // 创建STYLE中样式
  //   var style = new GC.Spread.Sheets.Style();
  //   Object.assign(style, styleObj)
  //   this.STYLE[keyName] = style;
  // }

  // setCellsStyle(cellsArr, sheet, definedStyle) {
  //   var st = sheet || this.activeSheet;
  //   var style = this.STYLE[definedStyle];
  //   if (cellsArr && cellsArr.length) {
  //     cellsArr.forEach(cell => {
  //       st.setStyle(cell[0], cell[1], style);
  //     })
  //   }
  // }
  // addCellsStyle() {
  //   this.activeSheet.getStyle(1, 1, GC.Spread.Sheets.SheetArea.viewport);
  // }
  // getData() { // 获取表格数据
  //   return JSON.stringify(this.spread.toJSON());
  // }
  // setData(json) { // 设置表格数据
  //   this.spread.fromJSON(JSON.parse(json));
  // }
  // getSheetByIndex(index) { // 根据index获取sheet
  //   return this.spread.getSheet(index)
  // }
  // setSheetArea(sheet, rowCount, colCount) { // 设置表格行列
  //   var SheetArea = this.SheetArea;
  //   // sheet.setRowCount(rowCount, SheetArea.colHeader);
  //   sheet.setRowCount(rowCount, SheetArea.viewport);
  //   // sheet.setColumnCount(colCount, SheetArea.rowHeader);
  //   sheet.setColumnCount(colCount, SheetArea.viewport);
  //   return sheet;
  // }
  // appendSheet(sheetName) { // 末尾添加表格
  //   var sheet = new GC.Spread.Sheets.Worksheet(sheetName);
  //   this.spread.addSheet(this.spread.sheets.length, sheet);
  // }
  // delSheetByIndex(index) { // 根据index删除表格
  //   this.spread.removeSheet(index);
  // }
  // setRedBorder(sheet, row, col, rowCount = 1, colCount = 1) { // 设置红色边框
  //   rowCount = rowCount || 1;
  //   colCount = colCount || 1;
  //   var range = sheet.getRange(row, col, rowCount, colCount);
  //   range.setBorder(new GC.Spread.Sheets.LineBorder('red', GC.Spread.Sheets.LineStyle.thick), { all: true });
  // }
  setNormalBorder(sheet, row, col, rowCount = 1, colCount = 1) {
    rowCount = rowCount || 1;
    colCount = colCount || 1;
    var range = sheet.getRange(row, col, rowCount, colCount) ;
    range.setBorder(null, { all: true });
  }

  // setColumnText(sheet, col: number, text: string) { // 设置表头文字信息
  //   sheet.setCellType(0, col, new DefineColumnText(text), GC.Spread.Sheets.SheetArea.colHeader);
  // }
  // setMoreLinkCell(sheet: SPREAD.Worksheet, row: number, col: number, linkArr: any[], callback: (text: string) => any) { // 设置多链接类型
  //   sheet.setCellType(row, col, new MoreLinkCellType(linkArr, callback), GC.Spread.Sheets.SheetArea.viewport);
  // }
  // setMoreButtonCell(sheet: SPREAD.Worksheet, row: number, col: number, buttonArr: any[], callback: (text: string, sheet: SPREAD.Worksheet, row: number, col: number) => any) { // 设置多按钮类型
  //   sheet.setCellType(row, col, new MoreButtonCellType(buttonArr, callback), GC.Spread.Sheets.SheetArea.viewport);
  // }
  // setNormalButton(sheet: SPREAD.Worksheet, row: number, col: number, text: string, callback: (sheet: SPREAD.Worksheet, row: number, col: number) => any) { // 设置普通按钮类型
  //   var b1 = new SELFButton();
  //   b1.marginLeft(15);
  //   b1.marginTop(7);
  //   b1.marginRight(15);
  //   b1.marginBottom(7);
  //   b1.text(text);
  //   b1.buttonBackColor('rgb(227,114,158)');
  //   // b1.__callback = callback;
  //   b1.bind(GC.Spread.Sheets.Events.ButtonClicked, function (e) {
  //     callback(e.sheet, e.row, e.col);
  //   });
  //   sheet.setCellType(row, col, b1, this.SheetArea.viewport);
  //   sheet.getCell(row, col).foreColor('white');
  // }
  // setAutocusCell(sheet: SPREAD.Worksheet, row: number, col: number, array: any[], rightCallback: (context: any) => any, wrongCallback: (context: any) => any): void { // 设置自动填充类型
  //   sheet.setCellType(row, col, new AutocompleteCellType(array, rightCallback, wrongCallback));
  // }
  // setUnblurCell(sheet: SPREAD.Worksheet, row: number, col: number, callbackName: string, blurCallback: (sheet: SPREAD.Worksheet, row: number, col: number, value: string, oldValue?: string) => void, needJudgeValue: boolean = false) { // 设置自动填充类型
  //   sheet.setCellType(row, col, new UnblurCellType(callbackName, blurCallback, needJudgeValue));
  // }
  // setSelectCell(sheet: SPREAD.Worksheet, row: number, col: number, optionsName: string, options: any, callback: any = null): void { // 设置下拉选项类型
  //   sheet.setCellType(row, col, new SelectCellType(optionsName, options, callback));
  // }
  autoJudgeTypeCellType(sheet, row, col) { // 设置搜索类 todo blur事件兼容
    sheet.setCellType(row, col, new AutoJudgeTypeCellType());
  }
  // setTextCell(sheet: SPREAD.Worksheet, row: number, col: number): void { // 设置文本类型
  //   sheet.setCellType(row, col, new TEXTCELLTYPE());
  // }
  // setAutoJudgeTyptArr(type: string, arr: any[]): void { // 设置PARAM,INSTRUCT,REMOTPARAM,FUNCTION可搜索值
  //   //@ts-ignore
  //   AutoJudgeTypeCellType[type] = arr;
  // }
  // setAutoJudgeSimType(type: boolean): void { // 设置PARAM,INSTRUCT,REMOTPARAM,FUNCTION可搜索值
  //   //@ts-ignore
  //   AutoJudgeTypeCellType.isSim = type;
  // }
  // setTimePickerCellType(sheet: SPREAD.Worksheet, row: number, col: number): void {
  //   // sheet.setCellType(row, col, new TimepickercellType());
  // }
  // setEmptyCellType(sheet: SPREAD.Worksheet, row: number, col: number): void {
  //   sheet.setCellType(row, col, new EMPTYCELLTYPE());
  // }
  // isEmptyCellType(sheet: SPREAD.Worksheet, row: number, col: number): boolean {
  //   return sheet.getCellType(row, col) instanceof EMPTYCELLTYPE;
  // }
  // setLayercellType(sheet: SPREAD.Worksheet, row: number, col: number, callback: (context: any) => any): void {
  //   // @ts-ignore
  //   sheet.setCellType(row, col, new LAYERCELLTYPE(callback, row, col));
  // }
  // isLayercellType(sheet: SPREAD.Worksheet, row: number, col: number): boolean {
  //   return sheet.getCellType(row, col) instanceof LAYERCELLTYPE;
  // }
  // nextNeedValuesForIf = ['ELSE', 'END']
  // nextNeedNotJudgeValuesForIf = ['IF', 'WHILE']
  // specialKeys = ['IF', 'ELSE', 'END', 'WHILE']
  // allowedStrings = ['IFELSE', 'IFEND', 'ELSEEND', 'WHILEEND']
  // nextNeedValuesForWHILE = ['END']
  // judgeNeedAutoAdd(sheet: SPREAD.Worksheet, startRow: number, nextNeedValues: any[], nextNeedNotJudgeValues: any[] = []): boolean {
  //   var rowCount = sheet.getRowCount();
  //   var curKeys = sheet.getArray(0, 0, rowCount, 1);
  //   var flag = false;
  //   for (var i = startRow + 1; i < rowCount; i++) {
  //     var cur = curKeys[i][0] && curKeys[i][0].trim();
  //     if (cur && nextNeedNotJudgeValues && nextNeedNotJudgeValues.indexOf(cur) > -1) {
  //       flag = true;
  //       break;
  //     }
  //     if (cur && nextNeedValues.indexOf(cur) > -1) {
  //       for (var j = startRow - 1; j >= 0; j--) {
  //         var curPre = curKeys[j][0] && curKeys[j][0].trim();
  //         if (curPre && this.specialKeys.indexOf(curPre) > -1 && this.allowedStrings.indexOf(curPre + cur) > -1) {
  //           flag = true;
  //           break;
  //         }
  //       }
  //       break;
  //     }
  //     if (flag) { break; }
  //   }
  //   if (i == rowCount) {
  //     flag = true;
  //   }
  //   return flag;
  // }
  checkKeyWordExplain() {}
  // //instructExplain是为了在选择动态指令时添加详细注释
  // checkKeyWordExplain(sheet: SPREAD.Worksheet, row: number, col: number, doNotAdd: boolean = false, instructExplain: string = ''): void {
  //   var isChoiceKeyWord = col == 0;
  //   var keyWord: SPREAD.keyWordsText = sheet.getValue(row, 0) && String(sheet.getValue(row, 0)).trim(); // 关键字
  //   var keyWordCellType = sheet.getCellType(row, 0);
  //   var instruct = sheet.getValue(row, 2) && String(sheet.getValue(row, 2)).trim(); // 指令或参数
  //   var instructCellType = sheet.getCellType(row, 2);
  //   var judgeValue = sheet.getValue(row, 3) && String(sheet.getValue(row, 3)).trim(); // 判读要求
  //   var explain = sheet.getValue(row, 1); // 程序内容要求
  //   var rule = judgeObj.rules;
  //   var resultText;
  //   var that = this;
  //   if (keyWord) { // 如果已经选择关键字
  //     if (judgeObj.needNot.indexOf(keyWord) > -1) {
  //       return;
  //     }
  //     var explainCell = sheet.getRange(row, 1)
  //     if (keyWord == 'BLOCK') {
  //       explainCell.font('bold normal 15px normal');
  //       return;
  //     } else if (keyWord == 'NOTE') {
  //       explainCell.font('italic normal 15px normal');
  //       explainCell.foreColor('green');
  //       return;
  //     } else {
  //       sheet.getRange(row, 1).font(undefined);
  //     }
  //     if (Object.keys(judgeObj.keyWordsText).includes(keyWord)) { // 如果是固定文字类
  //       sheet.setValue(row, 1, judgeObj.keyWordsText[keyWord as SPREAD.staticKey]);
  //       return;
  //     }
  //     if (!doNotAdd && isChoiceKeyWord && keyWord == 'IF' && this.judgeNeedAutoAdd(sheet, row, this.nextNeedValuesForIf, this.nextNeedNotJudgeValuesForIf)) {
  //       sheet.addRows(row + 1, 4);
  //       sheet.setArray(row, 0, [['IF'], [], ['ELSE'], [], ['END_IF', '条件语句结束']]);
  //       return;
  //     }
  //     if (!doNotAdd && isChoiceKeyWord && keyWord == 'WHILE' && this.judgeNeedAutoAdd(sheet, row, this.nextNeedValuesForWHILE)) {
  //       sheet.addRows(row + 1, 2);
  //       sheet.setArray(row, 0, [['WHILE'], [], ['END_WHILE', '循环语句结束']]);
  //       return;
  //     }
  //     if (!doNotAdd && isChoiceKeyWord && keyWord == 'EXTER') {
  //       sheet.addRows(row + 1, 2);
  //       sheet.setArray(row, 0, [['EXTER'], [], ['END_EXTER']]);
  //       return;
  //     }
  //     if (!instruct && !judgeValue) { // 如果指令，判读都未填
  //       sheet.setValue(row, 1, '');
  //       return;
  //     }
  //     var instructText = instruct ? this.getInstructNameText(instruct, instructExplain).join(',') : '';
  //     var funcText = '';
  //     if (judgeValue) {
  //       var funcArr = judgeValue.match(/#(.+?)#/g);
  //       judgeValue = this.getRemoteParanNameText(judgeValue).join(',');
  //       if (funcArr && Array.isArray(funcArr) && funcArr.length) {
  //         funcText = '执行';
  //         funcArr.forEach(e => {
  //           var curFunc = e.replace(/#/g, '');
  //           funcText += that.getFuncNameAndParamFromText(curFunc)
  //         })
  //       }
  //     }
  //     judgeValue += funcText;
  //     switch (keyWord) {
  //       case 'ASYNC':
  //         // if (explain && !(rule.empty.test(explain) || rule.async.test(explain))) { break; }
  //         if (instruct) {
  //           // var text = instructCellType.cellType == '指令' ? instruct : this.getFuncNameAndParamFromText(instruct);
  //           resultText = '发送' + instructText + '，不等待回令';
  //         }
  //         if (judgeValue) {
  //           resultText = resultText ? resultText + '，判读' + judgeValue : '判读' + judgeValue;
  //         }
  //         break;
  //       case 'CALL':
  //         // if(explain && !rule.call.test(explain)) {break;}
  //         // if (instruct) {
  //         //   resultText = '调用用例' + instruct;
  //         // }
  //         break;
  //       case 'SET':
  //         if (instruct) {
  //           resultText = '设定全局变量' + instruct;
  //         }
  //         break;
  //       case 'WAIT': 
  //         if (instruct) {
  //           resultText = '等待' + instruct + '秒';
  //         }
  //         break;
  //       case 'RECORD':
  //         if(judgeValue) {
  //           resultText = '记录' + judgeValue + '值';
  //         }
  //     }

  //   } else {
  //     if (!instruct && !judgeValue) { // 如果指令，判读都未填
  //       sheet.setValue(row, 1, '');
  //       return;
  //     }
  //     // if (explain && !(rule.empty.test(explain) || rule.async.test(explain))) { return; }
  //     var instructText = instruct ? this.getInstructNameText(instruct, instructExplain).join('\n') : '';
  //     var funcText = '';
  //     var newjudgeValue = '';
  //     if (judgeValue) {
  //       var funcArr = judgeValue.match(/#(.+?)#/g);
  //       newjudgeValue = this.getRemoteParanNameText(judgeValue).join('\n');
  //       if (funcArr && Array.isArray(funcArr) && funcArr.length) {
  //         funcText = '执行';
  //         funcArr.forEach(e => {
  //           var curFunc = e.replace(/#/g, '');
  //           funcText += that.getFuncNameAndParamFromText(curFunc)
  //         });

  //       }
  //       !!funcText && (newjudgeValue += '\n' + funcText);
  //     }

  //     if (instruct) {
  //       // instruct = String(instruct).replace(/\n/g, ',');
  //       resultText = '发送' + instructText;
  //     }
  //     if (newjudgeValue) {
  //       // judgeValue = String(judgeValue).replace(/\n/g, ',');
  //       resultText = resultText ? resultText + '\n判读' + newjudgeValue : '判读' + newjudgeValue;
  //     } else if (judgeValue) {
  //       resultText = resultText ? resultText + '\n判读' + judgeValue : '判读' + judgeValue;
  //     }
  //   }

  //   if (resultText) {
  //     resultText = resultText.replace(/,+/g, ',')
  //     sheet.setValue(row, 1, resultText);
  //   }
  // }

  // checkSimInstructionOrParamOrSubsys(sheet: SPREAD.Worksheet, row: number, col: number) {
  //   const value = sheet.getValue(row, col);
  //   if (!value) { 
  //     return;
  //   }
  //   let type = needResetCols.indexOf(col) >= 0 ? 'instruct' : '';
  //   type === '' && (type = col == 9 ? 'param' : 'subsys');
  //   let explain = '';
  //   if(type == 'instruct') {
  //     for(let i = 0; i < 4; i++) {
  //       if(needResetCols[i] != col) {
  //         sheet.setValue(row, needResetCols[i], '');
  //       }
  //     }
  //     const instructText = value ? this.getInstructNameText(value, '').join('\n') : '';
  //     sheet.setValue(row, 5, instructText)
  //     explain = '发送' + instructText;
  //     const judgeValue = sheet.getValue(row, 9) && String(sheet.getValue(row, 9)).trim(); // 判读要求
  //     if(judgeValue) {
  //       explain += explain ? ',' : '';
  //       explain += '判读' + judgeValue
  //     }
  //   }
  //   if(type == 'param') {
  //     const instructText = sheet.getValue(row, 5) && String(sheet.getValue(row, 5)).trim();
  //     instructText && (explain = '发送' + instructText)
  //     const judgeValue = sheet.getValue(row, 9) && String(sheet.getValue(row, 9)).trim(); // 判读要求
  //     if(judgeValue) {
  //       explain += explain ? ',' : '';
  //       explain += '判读' + judgeValue
  //     }
  //   }
  //   explain && sheet.setValue(row, 6, explain);
  // }
  // getInstructNameText(instruct: string, instructExplain: string): any[] {
  //   var instructPool = AutoJudgeTypeCellType.INSTRUCTREAL;
  //   var instructNamePool = AutoJudgeTypeCellType.INSTRUCTNAME;
  //   var arr = this.judgeInstruct(instruct);
  //   var result = arr.map(function (e, i) {
  //     var str = e.indexOf('.') > 0 ? e.split('.')[1] : e;
  //     str = str.indexOf('$') > 0 ? str.split('$')[0] : str;
  //     var index = instructPool.indexOf(str);
  //     return index >= 0 ? instructNamePool[index] : e;
  //   })
  //   if (instructExplain) {
  //     result[result.length - 1] = instructExplain;
  //   }
  //   return result;
  // }
  // getRemoteParanNameText(paramstr: string): any[] {
  //   var paramPool = AutoJudgeTypeCellType.REMOTPARAM;
  //   var paramRealPool = AutoJudgeTypeCellType.REMOTPARAMREAL;
  //   var arr = this.judgeRemoteParam(paramstr);
  //   var result = arr.map(function (e, i) {
  //     var str = e.indexOf('.') < 0 ? 'DATE.' + e : e;
  //     if (/_PREV$/.test(str)) {
  //       str = str.slice(0, -5);
  //     }
  //     if (/_YM$/.test(str)) {
  //       str = str.slice(0, -3);
  //     }
  //     var index = paramPool.indexOf(str);
  //     str = str.split('.')[1] || str;
  //     return index >= 0 ? paramRealPool[index].replace(new RegExp(str), e) : e;
  //   })
  //   return result;
  // }
  // splitByExter(keyArr: string[][]) {
  //   var exterAndExendArr: Array<any> = [];
  //   var exterarr: any[] = [];
  //   var rightArr: any[] = [];
  //   var wrongArr: any[] = [];
  //   var outerArr: any[] = [];
  //   var curKey = '';
  //   keyArr.forEach((e, i) => {
  //     curKey = e[0];

  //     if (curKey == 'EXTER') {
  //       exterAndExendArr.push({
  //         key: curKey,
  //         row: i
  //       })
  //       exterarr.push(exterAndExendArr.length - 1);
  //     } else if (curKey == 'END_EXTER') {
  //       exterAndExendArr.push({
  //         key: curKey,
  //         row: i
  //       })
  //     }
  //   });
  //   var len = exterarr.length;
  //   if (!len) {
  //     return {
  //       doNotSplit: true,
  //       wrongArr: wrongArr,
  //       rightArr: rightArr,
  //       outerArr: outerArr
  //     }
  //   }
  //   var curStart, next, spliceNum = 1;
  //   for (var i = len - 1; i >= 0; i--) {
  //     curStart = exterarr[i];
  //     next = exterAndExendArr[curStart + 1];
  //     spliceNum = 1;
  //     if (!next || next.key == 'EXTER') {
  //       wrongArr.push(exterAndExendArr[curStart].row)
  //     } else {
  //       if (this.spread && this.activeSheet) {
  //         if (this.activeSheet.getValue(exterAndExendArr[curStart].row, 1)) {
  //           rightArr.push([exterAndExendArr[curStart].row, next.row]);
  //         } else {
  //           this.activeSheet.comments.add(exterAndExendArr[curStart].row, 1, '缺少必填标记，无法作为插入点');
  //           this.setRedBorder(this.activeSheet, exterAndExendArr[curStart].row, 1);
  //         }
  //       }
  //       spliceNum++;
  //     }
  //     exterAndExendArr.splice(curStart, spliceNum);
  //   }
  //   var doNotSplit = rightArr.length ? false : true;
  //   var rightLen = rightArr.length;
  //   if (rightLen) {
  //     var curNeed = null;
  //     for (var i = rightLen - 1; i >= 0; i--) {
  //       var curRight = rightArr[i];
  //       if (!curNeed || curRight[1] > curNeed[1]) {
  //         outerArr.push(curRight);
  //         curNeed = curRight;
  //       }
  //     }
  //   }
  //   return {
  //     doNotSplit: doNotSplit,
  //     wrongArr: wrongArr,
  //     rightArr: rightArr,
  //     outerArr: outerArr
  //   }
  // }
  // setTextIndent(sheet: SPREAD.Worksheet, startRow: number, endRow: number) {
  //   var rowCount = endRow - startRow - 1;
  //   var oldIndent = sheet.getCell(startRow, 0).textIndent();
  //   if (!oldIndent || oldIndent == -3) {
  //     sheet.getCell(startRow, 0).textIndent(0);
  //     sheet.getCell(endRow, 0).textIndent(0);
  //     oldIndent = 0;
  //   }
  //   if (rowCount > 0) {
  //     for (var i = startRow + 1; i < endRow; i++) {
  //       oldIndent = sheet.getCell(i, 0).textIndent();
  //       oldIndent = !oldIndent || oldIndent == -3 ? 1 : oldIndent + 1;
  //       // oldIndent =  oldIndent + 1 : 1;
  //       sheet.getCell(i, 0).textIndent(oldIndent);
  //     }
  //   }
  // }
  // getFuncNameAndParamFromText(text: string) {
  //   var funcName, params;
  //   funcName = text.match(/\w+/) ? (text.match(/\w+/) as string[])[0] : null;
  //   if (funcName) {
  //     params = text.match(/\([\s\S]*\)/) && (text.match(/\([\s\S]*\)/) as string[])[0].slice(1, -1);
  //     if (params) { return ['函数', funcName, ',参数', params].join('') } else {
  //       return text;
  //     }
  //   } else {
  //     return text;
  //   }
  // }
  // initOutlineColumn(sheet: SPREAD.Worksheet) { // 按照textindent折叠
  //   sheet.outlineColumn.options({
  //     columnIndex: 0,
  //     showImage: true,
  //     showCheckBox: false,
  //     // images: [ '$DEMOROOT$/spread/source/images/archiverFolder.png', '$DEMOROOT$/spread/source/images/newFloder.png', '$DEMOROOT$/spread/source/images/docFile.png' ],
  //     expandIndicator: require('@/assets/increaseIndicator.png').default,
  //     collapseIndicator: require('@/assets/decreaseIndicator.png').default,
  //     // maxLevel: 10
  //   });
  //   sheet.showRowOutline(false);
  //   sheet.outlineColumn.refresh();
  // }
  // judgeEliggle(value: any, col: number, keyWord: SPREAD.keyWordsText) { // 检测指令，参数，封装函数是否存在，写法是否标准
  //   if (value == undefined || value == null) return [];
  //   value = value.toString().trim();
  //   var result = this.judgeParam(value);
  //   var paramResult = result.paramArr;
  //   if (result.err) {
  //     return [result.err];
  //   }
  //   value = result.str.replace(/\[(.+?)\]|\{(.+?)\}|/g, '');
  //   if (keyWord == 'SET') {
  //     if (!/^G_Flag/.test(value) && col == 2) {
  //       return ['全局变量定义方式错误'];
  //     } else {
  //       return this.judgeParamComments(paramResult, true);
  //     }
  //   }
  //   if(keyWord == 'WAIT') {
  //     if (!/^[0-9]+(\.?[0-9]+)?$/.test(value) && col == 2) {
  //       return ['等待时间格式错误'];
  //     } else {
  //       return []
  //     }
  //   } 
  //   if (keyWord == 'CALL' || keyWord == 'NOTIFY' || keyWord == 'TODO') return [];
  //   var funcArr = value.match(/#(.+?)#/g);
  //   var funcLen = funcArr && funcArr.length || 0;
  //   var funcResult: string[] = [];
  //   var instructArr: string[] = [];
  //   var remoteParamArr: string[] = [];
  //   var resultValue = value.replace(/\[(.+?)\]|#(.+?)#|\{(.+?)\}/g, '').trim();
  //   if (col == 2 && resultValue) { // 截取指令
  //     instructArr = this.judgeInstruct(resultValue);
  //   }
  //   if (col == 3 && resultValue) { // 判读列的处理。需要完善，如参数间有-号
  //     remoteParamArr = this.judgeRemoteParam(value)
  //   }
  //   return this.judgeComments(paramResult, funcResult, instructArr, remoteParamArr, keyWord);
  // }
  // judgeParam(value: string) {
  //   var result = {
  //     str: value,
  //     paramArr: [] as string[],
  //     err: '',
  //   }
  //   if (value.indexOf('{') < 0 && value.indexOf('(') < 0) return result;
  //   var valueArr = value.split('');
  //   var arr = [];
  //   var startArr = [];
  //   var bracketsArr = [];
  //   var bracketsStartArr = [];
  //   for (var i = 0; i < value.length; i++) {
  //     var cur = value[i];
  //     if (cur == '{' || cur == '}') {
  //       if (cur == '{') {
  //         startArr.push(arr.length)
  //       }
  //       arr.push({
  //         index: i,
  //         icon: cur
  //       });
  //     } else if (cur == '(' || cur == ')') {
  //       if (cur == '(') {
  //         bracketsStartArr.push(bracketsArr.length)
  //       }
  //       bracketsArr.push(cur);
  //     }
  //   }
  //   if (arr.length - startArr.length != startArr.length) {
  //     result.err = '{}标签未闭合'
  //   }
  //   if (arr.length - startArr.length != startArr.length) {
  //     result.err = '()标签未闭合'
  //   }
  //   if (result.err || !arr.length) return result;
  //   for (var j = startArr.length - 1; j >= 0; j--) {
  //     if (arr[startArr[j] + 1].icon == '}') {
  //       var curinfo = value.slice(arr[startArr[j]].index + 1, arr[startArr[j] + 1].index);
  //       if (!curinfo) continue;
  //       if (curinfo.indexOf(',') < 0) {
  //         result.paramArr.push(curinfo);
  //       }
  //       var num = arr[startArr[j] + 1].index - arr[startArr[j]].index + 1;
  //       var empArr = new Array(num);
  //       empArr.unshift(arr[startArr[j]].index, num);
  //       valueArr.splice.apply(valueArr, empArr as spliceArray);
  //     }
  //   }
  //   result.str = valueArr.join('').replace(/' '+/g, '');
  //   return result;
  // }
  // judgeParamComments(paramArr: string[], isSetKey: boolean): string[] {
  //   var commentsArr: string[] = [];
  //   var paramArrlen = paramArr.length;
  //   if (paramArrlen) {
  //     var paramPool = AutoJudgeTypeCellType.prototype.getParams();
  //     for (var paramI = 0; paramI < paramArrlen; paramI++) {
  //       var curParam = paramArr[paramI];
  //       if (!curParam || !String(curParam).trim()) {
  //         continue;
  //       }
  //       curParam = curParam.replace(/\{|\}/g, '');
  //       var curCode = curParam;
  //       var index = curParam.indexOf(':');
  //       if (index > 0) {
  //         curCode = curParam.slice(0, index);
  //         if (paramPool.codeArr.indexOf(curCode) >= 0) {
  //           if (paramPool.typeArr.indexOf(curParam) < 0) {
  //             commentsArr.push('参数' + curCode + '值错误')
  //           } else if (isSetKey) {
  //             var index = paramPool.codeArr.indexOf(curCode);
  //             var type = paramPool.paramTypeArr[index];
  //             //@ts-ignore
  //             if (!type || type != '整型' || type != '二进制') {
  //               commentsArr.push('参数' + curCode + '类型错误')
  //             }
  //           }
  //         } else {
  //           commentsArr.push('参数' + curCode + '未定义')
  //         }
  //       } else {
  //         if (paramPool.codeArr.indexOf(curParam) < 0) {
  //           commentsArr.push('参数' + curParam + '未定义')
  //         } else if (isSetKey) {
  //           var index = paramPool.codeArr.indexOf(curCode);
  //           var type = paramPool.paramTypeArr[index];
  //           if (!type || (type != '整型' && type != '二进制')) {
  //             commentsArr.push('参数' + curCode + '类型错误')
  //           }
  //         }
  //       }
  //     }
  //   }
  //   return commentsArr;
  // }
  // judgeInstruct(str: string): string[] {
  //   var resultValue = str.replace(/\((.+?)\)/g, '').replace(/,|，/g, '\n');
  //   return resultValue.split('\n');
  // }
  // judgeRemoteParam(str: string) {

  //   str = str.replace(/\+-/g, '+').replace(/--/g, '-').replace(/\*-/g, '*').replace(/\/-/g, '/').replace(/=-/g, '=').replace(/~-/g, '~'); // 把负数改为正数
  //   str = str.replace(/:B\d+~B\d+/g, '').replace(/:B\d+/g, '').replace(/:?\d*\.{0,1}\d*~\d*\.{0,1}\d*[ΩVuVkVAmA]?/g, '')
  //     .replace(/\[-?\d*\.{0,1}\d*,-?\d*\.{0,1}\d*\][ΩVuVkVAmA]?/g, '').replace(/\(\d*\.{0,1}\d*,\d*\.{0,1}\d*\)[ΩVuVkVAmA]?/g, '');
  //   str = str.replace(/\(\S*\)[ΩVuVkVAmA]?/g, '');
  //   var arr = str.replace(/\+|-|\*|\/|%|==|\[(.+?)\]|\{(.+?)\}|:|~|,|，|!=|&&|\|\||&|\||>>|<<|>|</g, '\n').split('\n');
  //   var result: string[] = [];
  //   arr.forEach(e => {
  //     if (/(0[xX])[A-Fa-f0-9]+|(0[bB])[0-7]+|^\d+[ΩVuVkVAmA]?/.test(e) || e === 'true' || e === 'false' || canUseFuncArr.indexOf(e) > -1) { // 排除数字和带单位的数字

  //     } else {
  //       e && result.push(String(e).trim())
  //     }
  //   })
  //   return result;
  // }
  // judgeComments(paramArr: string[], funcArr: string[], instructArr: string[], remoteParamArr: string[], keyword: SPREAD.keyWordsText) {
  //   var commentsArr: string[] = [];
  //   var paramArrlen = paramArr.length;
  //   commentsArr = commentsArr.concat(this.judgeParamComments(paramArr, keyword == 'SET'))
  //   var funcLen = funcArr.length;
  //   if (funcLen) {
  //     var funcPool = AutoJudgeTypeCellType.FUNCTION;
  //     for (var funcI = 0; funcI < funcLen; funcI++) {
  //       var curFunc = funcArr[funcI];
  //       //@ts-ignore
  //       var relateFunc = AutoJudgeTypeCellType.prototype.findIndex(funcPool, curFunc, 0, funcPool.length);
  //       if (relateFunc && funcPool[relateFunc] != curFunc) {
  //         commentsArr.push('函数' + curFunc + '不存在')
  //       }
  //     }
  //   }
  //   var instructLen = instructArr.length;
  //   var needJudgeInstruct = keyword != 'BLOCK' && keyword != 'CALL' && keyword != 'NOTIFY' && keyword != 'TODO' && keyword != 'WAIT';
  //   if (instructLen && needJudgeInstruct) {
  //     var instructPool = AutoJudgeTypeCellType.INSTRUCTREAL;
  //     for (var instructI = 0; instructI < instructLen; instructI++) {
  //       var curInstruct = instructArr[instructI].trim();
  //       curInstruct = curInstruct.replace(/\(\)/g, '');
  //       if (!curInstruct || /^G_Flag/.test(curInstruct) || 'true' === curInstruct || 'false' === curInstruct) {
  //         continue;
  //       }
  //       curInstruct = curInstruct.indexOf('.') > 0 ? curInstruct.split('.')[1] : curInstruct;
  //       curInstruct = curInstruct.indexOf('$') > 0 ? curInstruct.split('$')[0] : curInstruct;
  //       // var relateInstruct = AutoJudgeTypeCellType.prototype.findIndex(instructPool, curInstruct, 0, instructPool.length, true, doNotSplit);
  //       if (instructPool.indexOf(curInstruct) < 0) {
  //         commentsArr.push('指令' + curInstruct + '不存在')
  //       }
  //     }
  //   }
  //   var remoteParamLen = remoteParamArr.length;
  //   if (remoteParamLen) {
  //     var remoteParamPool = AutoJudgeTypeCellType.REMOTPARAM;
  //     for (var paramI = 0; paramI < remoteParamLen; paramI++) {
  //       var curParam: string = remoteParamArr[paramI];
  //       //@ts-ignore
  //       if (Number(curParam) == curParam || /^Ox|OX|Ob|OB|G_Flag/.test(curParam)) {
  //         continue;
  //       }
  //       if(canUseFuncArr.indexOf(curParam) > -1) {
  //         continue;
  //       }
  //       curParam = curParam.indexOf('.') > 0 ? curParam : 'DATE.' + curParam;
  //       if(/=/.test(curParam)) {
  //         commentsArr.push('请将“=”改为“==”')
  //       }
  //       if (/_PREV$/.test(curParam)) {
  //         curParam = curParam.slice(0, -5);
  //       }
  //       if (/_YM$/.test(curParam)) {
  //         curParam = curParam.slice(0, -3);
  //       }
  //       if (remoteParamPool.indexOf(curParam) < 0) {
  //         commentsArr.push('遥测参数' + curParam + '不存在')
  //       }
  //     }
  //   }
  //   return commentsArr;
  // }
  // setCopyData() {
  //   var sheet = this.activeSheet;
  //   var curCellInfo = sheet.getSelections()[0];
  //   var copyedData = localStorage.getItem(this._copyValue) && JSON.parse(localStorage.getItem(this._copyValue) as string);
  //   if (!copyedData) {
  //     // layer.msg('没有可复制的信息');
  //     return;
  //   }
  //   var dataRow = copyedData.length;
  //   var dataCol = copyedData[0].length;
  //   var rowCount = sheet.getRowCount();
  //   var colCount = sheet.getColumnCount();

  //   var startCol = 0;
  //   if (dataCol != colCount) {
  //     if (dataCol + curCellInfo.col > colCount) {
  //       // layer.msg('超出最大列数');
  //       return;
  //     }
  //     startCol = curCellInfo.col;
  //   }
  //   if (dataRow + curCellInfo.row > rowCount) {
  //     sheet.addRows(rowCount, dataRow + curCellInfo.row - rowCount);
  //   }
  //   if (sheet.getValue(curCellInfo.row, 0) === "CALL") {
  //     for (var ri = 0; ri < dataRow; ri++) {
  //       for (var ci = 0; ci < dataCol; ci++) {
  //         var curCol = startCol + ci;
  //         var dataSource = sheet.getDataSource()[ri + curCellInfo.row]
  //         if (curCol == 2) {
  //           dataSource['order_or_params'] = copyedData[ri][ci];
  //           dataSource['inter_require'] = copyedData[ri][ci + 1];
  //           dataSource['content'] = '调用程序' + dataSource['inter_require'];
  //           //@ts-ignore
  //           sheet.getCellType(ri + curCellInfo.row, curCol).showValue = dataSource['inter_require'];
  //         } else if (curCol != 3) {
  //           sheet.setValue(ri + curCellInfo.row, startCol + ci, copyedData[ri][ci])
  //         }
  //       }
  //     }
  //   } else {
  //     for (var ri = 0; ri < dataRow; ri++) {
  //       for (var ci = 0; ci < dataCol; ci++) {
  //         sheet.setValue(ri + curCellInfo.row, startCol + ci, copyedData[ri][ci])
  //       }
  //     }
  //   }
  // }
}


// function DefineColumnText(text: string) { // 自定义表头类
//   this.text = text;
// }
// class DefineColumnText extends GC.Spread.Sheets.CellTypes.Base {
//   constructor(public text: string) {
//     super();
//   }

//   paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, w: number, h: number, style: GC.Spread.Sheets.Style, context?: any): void {
//     style.backColor = '#eeeeee';
//     // ctx.fillStyle = 'gray';
//     if (this.text) {
//       GC.Spread.Sheets.CellTypes.Base.prototype.paint.apply(this, [ctx, this.text, x, y, w, h, style, context]);
//     }
//   }
// }
// DefineColumnText.prototype = new GC.Spread.Sheets.CellTypes.Base();
// DefineColumnText.prototype.paint = function (ctx, value, x, y, w, h, style, context) {
//   style.backColor = '#eeeeee';
//   // ctx.fillStyle = 'gray';
//   if (this.text) {
//     GC.Spread.Sheets.CellTypes.Base.prototype.paint.apply(this, [ctx, this.text, x, y, w, h, style, context]);
//   }
// };



// export class MoreLinkCellType extends GC.Spread.Sheets.CellTypes.Base {
//   linkArr: string[] = [];
//   callback: ((param: string) => any) = () => { };
//   startX: number = 0;
//   startY: number = 0;
//   endX: number = 0;
//   endY: number = 0;
//   curIndex: number = -1;
//   textXArr: number[] = [];
//   ctrlDown: boolean = false;
//   oldValue: string = '';
//   constructor(linkArr: string[], callback: ((text: string) => any | null)) {
//     super()
//     this.linkArr = linkArr;
//     this.callback = callback
//   }

//   paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, w: number, h: number, style: GC.Spread.Sheets.Style, context?: any): void {
//     if (this.linkArr.length == 0) {
//       ctx.clearRect(x, y, w, h);
//       return;
//     }
//     // this.curIndex = value;
//     ctx.save();

//     // draw inside the cell's boundary
//     ctx.rect(x, y, w, h);
//     ctx.clip();
//     ctx.textBaseline = "top";
//     ctx.textAlign = 'start';
//     ctx.fillStyle = "gray";
//     var text = this.linkArr.join(',');
//     var textWidth = ctx.measureText(text).width;
//     var textHeight = parseFloat(ctx.font);
//     this.startX = x + (w - textWidth) / 2;
//     this.endX = this.startX + textWidth;
//     this.startY = y + (h - textHeight) / 2;
//     this.endY = this.startY + textHeight;
//     var len = this.linkArr.length;
//     this.textXArr = [];
//     for (var i = 0; i < len; i++) {
//       var txt = this.linkArr[i];
//       var curX = ctx.measureText(this.linkArr.slice(0, i).join(',') + (i == 0 ? '' : ',')).width + this.startX;
//       this.textXArr.push(curX);
//       if (i == this.curIndex) {
//         ctx.save();
//         ctx.fillStyle = 'red';
//         ctx.fillText(i == len - 1 ? txt : txt + ',', curX, this.startY);
//         ctx.restore();
//       } else {
//         ctx.save();
//         ctx.fillStyle = 'gray';
//         ctx.fillText(i == len - 1 ? txt : txt + ',', curX, this.startY);
//         ctx.restore();
//       }
//     }
//     ctx.restore();
//   }
//   getHitInfo(x: number, y: number, cellStyle: SPREAD.styleObj, cellRect: GC.Spread.Sheets.Rect, context: SPREAD.cellContext): SPREAD.selfHitInfo {
//     var info = { x: x, y: y, row: context.row, col: context.col, cellRect: cellRect, sheetArea: context.sheetArea, isReservedLocation: false, curIndex: -1 };
//     if (x > this.startX && x < this.endX && y > this.startY && y < this.endY) {
//       info.isReservedLocation = true;
//       info.curIndex = -1;
//       var len = this.textXArr.length;
//       for (var i = 0; i < len; i++) {
//         if (this.textXArr[i] > x) {
//           info.curIndex = i - 1;
//           break;
//         }
//       }
//       if (info.curIndex == -1) {
//         info.curIndex = i - 1;
//       }
//     }
//     return info;
//   };

//   processMouseMove(hitInfo: SPREAD.selfHitInfo): boolean {
//     var sheet = hitInfo.sheet as SPREAD.Worksheet;
//     var row = hitInfo.row, col = hitInfo.col;
//     sheet.getParent().commandManager().execute({ cmd: "editCell", sheetName: sheet.name(), row: row, col: col, newValue: sheet.getValue(row, col) });
//     this.curIndex = hitInfo.curIndex;
//     return true;
//   };

//   processMouseDown(hitInfo: SPREAD.selfHitInfo): boolean {
//     var sheet = hitInfo.sheet;
//     var row = hitInfo.row, col = hitInfo.col;
//     if (this.ctrlDown) {
//       if (typeof this.callback == 'function' && hitInfo.curIndex > -1) {
//         this.ctrlDown = false;
//         this.callback(this.linkArr[hitInfo.curIndex])
//       }
//     }
//     return true
//   };
//   processKeyDown(event: KeyboardEvent): boolean {
//     if (event.keyCode == 17) {
//       this.ctrlDown = true;
//     }
//     return true;
//   };

//   processKeyUp(event: KeyboardEvent): boolean {
//     if (event.keyCode == 17) {
//       this.ctrlDown = false;
//     }
//     return true
//   };

//   createEditorElement(): HTMLElement {
//     return document.createElement("input");
//   };

//   activateEditor(editorContext: HTMLElement, cellStyle: GC.Spread.Sheets.Style, cellRect: GC.Spread.Sheets.Rect, context?: any): HTMLElement {
//     GC.Spread.Sheets.CellTypes.Base.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
//     return editorContext;
//   };

//   isReservedKey(event: KeyboardEvent, context: any): boolean {
//     if (!context.isEditing && event.keyCode == 17) {
//       return true;
//     }
//     return false;
//   };

//   setEditorValue(editorContext: HTMLElement, value: string, context: any) {
//     editorContext.setAttribute('value', value)
//     this.oldValue = value;
//   };
//   getEditorValue(editorContext: HTMLElement, context: any) {
//     var val = (editorContext.getAttribute('value') as string).trim();
//     val = val.replace(/\n/g, ',');
//     this.linkArr = val.split(',');
//     return val;
//   };
//   updateEditor(editorContext: HTMLElement, cellStyle: GC.Spread.Sheets.Style, cellRect: GC.Spread.Sheets.Rect, context?: any): GC.Spread.Sheets.Rect {
//     if (editorContext) {
//       editorContext.style.width = cellRect.width + 'px';
//       editorContext.style.height = cellRect.height + 'px';
//     }
//     return cellRect
//   };
// }




// class MoreButtonCellType extends GC.Spread.Sheets.CellTypes.Base {
//   startX: number = 0;
//   startY: number = 0;
//   endX: number = 0;
//   endY: number = 0;
//   curIndex: number = -1;
//   buttonXArr: number[] = [];
//   callback: ((param: string, sheet: SPREAD.Worksheet, row: number, col: number) => any | null);
//   topPadding: number = 4;
//   leftPadding: number = 4;
//   marginRight: number = 4;
//   buttonArr: string[] = [];
//   constructor(buttonArr: string[], callback: ((param: string, sheet: SPREAD.Worksheet, row: number, col: number) => any | null)) {
//     super()
//     this.buttonArr = buttonArr;
//     this.callback = callback;
//   }

//   buttonLightColors = ['rgb(53,150,232)', 'rgb(227,114,158)', 'rgb(114,189,43)', 'rgb(246,178,14)', 'rgb(217,83,79)'];
//   buttonDarkColors = ['gray'];
//   paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, w: number, h: number, style: GC.Spread.Sheets.Style, context?: any): void {
//     var len = this.buttonArr.length;
//     if (len == 0) {
//       ctx.clearRect(x, y, w, h);
//       return;
//     }
//     this.curIndex = value;
//     ctx.save();

//     // draw inside the cell's boundary
//     ctx.rect(x, y, w, h);
//     ctx.clip();
//     ctx.textBaseline = "top";
//     ctx.textAlign = 'start';
//     ctx.fillStyle = "gray";
//     var textHeight = parseFloat(ctx.font) + this.topPadding * 2;
//     var text = this.buttonArr.join('');
//     var textWidth = ctx.measureText(text).width + len * this.leftPadding * 2 + (len - 1) * this.marginRight;
//     this.startX = x + (w - textWidth) / 2;
//     this.endX = this.startX + textWidth;
//     this.startY = y + (h - textHeight) / 2;
//     this.endY = this.startY + textHeight;
//     this.buttonXArr = [];
//     for (var i = 0; i < len; i++) {
//       text = this.buttonArr[i];
//       var curX = ctx.measureText(this.buttonArr.slice(0, i).join('')).width + i * this.leftPadding * 2 + (i == 0 ? 0 : i * this.marginRight) + this.startX;
//       var curButtonWidth = ctx.measureText(this.buttonArr[i]).width + this.leftPadding * 2;
//       var curEndX = curButtonWidth + curX;
//       this.buttonXArr.push(curX, curEndX);
//       if (i == this.curIndex) {
//         ctx.save();
//         ctx.fillStyle = this.buttonDarkColors[i % this.buttonDarkColors.length];
//         ctx.fillRect(curX, this.startY, curButtonWidth, textHeight);
//         ctx.fillStyle = '#ffffff';
//         ctx.fillText(text, curX + this.leftPadding, this.startY + this.topPadding);
//         ctx.restore();
//       } else {
//         ctx.save();
//         ctx.fillStyle = this.buttonLightColors[i % this.buttonLightColors.length];
//         ctx.fillRect(curX, this.startY, curButtonWidth, textHeight);
//         ctx.fillStyle = '#ffffff';
//         ctx.fillText(text, curX + this.leftPadding, this.startY + this.topPadding);
//         ctx.restore();
//       }
//     }
//     ctx.restore();
//   };
//   getHitInfo(x: number, y: number, cellStyle: SPREAD.styleObj, cellRect: GC.Spread.Sheets.Rect, context: SPREAD.cellContext): SPREAD.selfHitInfo {
//     var info = { x: x, y: y, row: context.row, col: context.col, cellRect: cellRect, sheetArea: context.sheetArea, isReservedLocation: false, curIndex: -1 };
//     if (x > this.startX && x < this.endX && y > this.startY && y < this.endY) {
//       info.isReservedLocation = true;
//       info.curIndex = -1;
//       var len = this.buttonXArr.length;
//       for (var i = 0; i < len; i++) {
//         if (this.buttonXArr[i] > x && i % 2 == 1) {
//           info.curIndex = (i - 1) / 2;
//           break;
//         }
//       }
//       // if (info.curIndex == -1) {
//       //   info.curIndex = i - 1;
//       // }
//     }
//     return info;
//   };
//   processMouseMove(hitInfo: SPREAD.selfHitInfo) {
//     var sheet = hitInfo.sheet as SPREAD.Worksheet;
//     var row = hitInfo.row, col = hitInfo.col, sheetArea = hitInfo.sheetArea;
//     sheet.getParent().commandManager().execute({ cmd: "editCell", sheetName: sheet.name(), row: row, col: col, newValue: hitInfo.curIndex });
//     return true;
//   };
//   processMouseUp(hitInfo: SPREAD.selfHitInfo) {
//     var sheet = hitInfo.sheet as SPREAD.Worksheet;
//     if (sheet && hitInfo.isReservedLocation && hitInfo.curIndex > -1) {
//       if (typeof this.callback == 'function') {
//         this.callback(this.buttonArr[hitInfo.curIndex], sheet, hitInfo.row, hitInfo.col)
//       }
//       return true;
//     }
//     return false;
//   };
// }

// export class ArrayLick {
//   constructor(public length: number) {

//   }
//   push(...argus: any[]) {
//     Array.prototype.push.apply(this, argus);
//   }
//   splice(...argus: [start: number, deleteCount: number, ...items: any[]]) {
//     Array.prototype.splice.apply(this, argus);
//   }
// }

// class AutocompleteCellType extends GC.Spread.Sheets.CellTypes.Base {
//   static availableTags?: string[];
//   static rightCallback?: (param: any) => any;
//   static wrongCallback?: (param: any) => any;
//   oldValue: string = '';
//   constructor(availableTags: string[], rightCallback: (context: any) => any, wrongCallback: (context: any) => any) {
//     super()
//     if (availableTags && availableTags.length && !AutocompleteCellType.availableTags) {
//       AutocompleteCellType.availableTags = availableTags;
//     }
//     if (rightCallback && !AutocompleteCellType.rightCallback) {
//       AutocompleteCellType.rightCallback = rightCallback;
//     }
//     if (wrongCallback && !AutocompleteCellType.wrongCallback) {
//       AutocompleteCellType.wrongCallback = wrongCallback;
//     }


//   }
//   createEditorElement(): HTMLElement {
//     SP.initSpreadApp()
//     //@ts-ignore
//     return document.getElementById('keyInput').parentNode.parentNode as HTMLElement
//     // return SP.spreadApp.$refs['keyInput'].$el;
//   };

//   activateEditor(editorContext: HTMLElement, cellStyle: GC.Spread.Sheets.Style, cellRect: GC.Spread.Sheets.Rect, context?: any): HTMLElement {
//     setTimeout(() => {
//       (editorContext.getElementsByTagName('input')[0] as any).focus()
//     }, 5)
//     GC.Spread.Sheets.CellTypes.Base.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
//     return editorContext
//   };
//   deactivateEditor(editorContext: HTMLElement, context: any) {
//     if (editorContext) {
//       const curValue = (editorContext.getElementsByTagName('input')[0] as any).value
//       context.oldValue = this.oldValue;
//       context.newValue = curValue;
//       if (!curValue || (AutocompleteCellType.availableTags as string[]).indexOf(curValue) != -1) {
//         AutocompleteCellType.rightCallback && AutocompleteCellType.rightCallback(context);
//       } else {
//         AutocompleteCellType.wrongCallback && AutocompleteCellType.wrongCallback(context);
//       }
//     }
//     SP.spreadApp.unmount()
//     GC.Spread.Sheets.CellTypes.Base.prototype.deactivateEditor.call(this, editorContext.getElementsByTagName('input')[0], context);
//   };
//   setEditorValue(editorContext: HTMLElement, value: string, context: any) {
//     // $(editorContext).val(value);
//     editorContext.setAttribute('value', value || '')
//     this.oldValue = value;
//   };
//   getEditorValue(editorContext: any, context: any): string | null {
//     return editorContext.getElementsByTagName('input')[0].value;
//   };
//   updateEditor(editorContext: HTMLElement, cellStyle: GC.Spread.Sheets.Style, cellRect: GC.Spread.Sheets.Rect, context: any): GC.Spread.Sheets.Rect {
//     if (editorContext) {
//       editorContext.style.width = cellRect.width + 'px'
//       editorContext.style.height = cellRect.height + 'px'
//     }
//     return cellRect
//   };
//   // isReservedKey (event, context) {
//   //   if (context.isEditing && (event.keyCode == 40 || event.keyCode == 38)) {
//   //     return true;
//   //   }
//   //   return false;
//   // };
// }




class AutoJudgeTypeCellType extends GC.Spread.Sheets.CellTypes.Base { // 自定义搜索填充类
  static selectUl
  searchTimer
  static formatters = ['{', '}', '#'];
  static 'INSTRUCT' = [];
  static 'INSTRUCTNAME' = [];
  static 'INSTRUCTREAL' = [];
  static 'INSTRUCTPARAM' = [];
  static 'PARAM' = [];
  static 'REMOTPARAM'= [];
  static 'REMOTPARAMREAL' = [];
  static 'FUNCTION'= [];
  static 'SUBSYS' = [];
  static isSim = false;
  constructor() {
    super()
    this.searchTimer = null;
  }

  compareString(bigger, littler) {
    var result = false;
    for (var i = 0; i < littler.length; i++) {
      if (bigger[i] > littler[i]) {
        result = true;
        break;
      } else if (bigger[i] < littler[i]) {
        break;
      }
    }
    return result;
  }
  findIndex = tailCallOptimize(
    //@ts-ignore
    function binarySerach(arr, val, leftIndex, RightIndex, isInstruct) { // 二分法查找
      var func = AutoJudgeTypeCellType.prototype.compareString;
      var mid = Math.floor((leftIndex + RightIndex) / 2);
      var midVal = arr[mid];
      if (!midVal) return;
      midVal = AutoJudgeTypeCellType.prototype.transData(isInstruct, midVal);
      if (midVal.indexOf(val) == 0 || (leftIndex + 1) == RightIndex) {
        return mid;
      } else if (func(midVal, val)) {
        return binarySerach(arr, val, leftIndex, mid, isInstruct);
      } else {
        return binarySerach(arr, val, mid, RightIndex, isInstruct);
      }
    }
  )

  judgeNodeIndex(element, pos) {
    var spans = $(element).find('.gcsj-func-color-text');
    var len = spans.length;
    var p = len - 1;
    var textLength = 0;
    var finalPos = pos;
    for (let i = 0; i < len; i++) {
      textLength += spans.eq(i).text().length;
      if (textLength >= pos) {
        p = i;
        break;
      } else {
        finalPos -= spans.eq(i).text().length;
      }
    }
    return [p, finalPos];
  }

  setPos(element, pos) {
    pos = pos !== undefined ? pos : $(element).text().length;
    var judgeResult = this.judgeNodeIndex(element, pos);
    element = $(element).hasClass('gcsj-func-color-text') ? element : $(element).find('.gcsj-func-color-text').get(judgeResult[0]);
    pos = judgeResult[1];
    var range, selection;
    if (!element) return;
    if (document.createRange)//Firefox, Chrome, Opera, Safari, IE 9+
    {
      range = document.createRange();//创建一个选中区域
      range.selectNodeContents(element);//选中节点的内容
      if (element.innerHTML.length > 0) {
        if (pos > (element.childNodes[0]).length) return;
        range.setStart(element.childNodes[0], pos); //设置光标起始为指定位置
      }
      range.collapse(true);       //设置选中区域为一个点
      selection = window.getSelection();//获取当前选中区域
      selection.removeAllRanges();//移出所有的选中范围
      selection.addRange(range);//添加新建的范围
    }
    // else if (document.selection)//IE 8 and lower
    // {
    //   range = document.body.createTextRange();//Create a range (a range is a like the selection but invisible)
    //   range.moveToElementText(element);//Select the entire contents of the element with the range
    //   range.collapse(false);//collapse the range to the end point. false means collapse to end rather than the start
    //   range.select();//Select the range (make it the visible selection
    // }
  }

  getPos = function (element) {
    var caretOffset = 0;
    var doc = element.ownerDocument || element.document;
    var win = doc.defaultView || doc.parentWindow;
    var sel;
    if (typeof win.getSelection != "undefined") {//谷歌、火狐
      sel = win.getSelection();
      if (sel.rangeCount > 0) {//选中的区域
        var range = win.getSelection().getRangeAt(0);
        var preCaretRange = range.cloneRange();//克隆一个选中区域
        preCaretRange.selectNodeContents(element);//设置选中区域的节点内容为当前节点
        preCaretRange.setEnd(range.endContainer, range.endOffset);  //重置选中区域的结束位置
        caretOffset = preCaretRange.toString().length;
      }
    } else if ((sel = doc.selection) && sel.type != "Control") {//IE
      var textRange = sel.createRange();
      var preCaretTextRange = doc.body.createTextRange();
      preCaretTextRange.moveToElementText(element);
      preCaretTextRange.setEndPoint("EndToEnd", textRange);
      caretOffset = preCaretTextRange.text.length;
    }
    return caretOffset;
  }

  createEditorElement(context) {
    var value = context.sheet.getValue(context.row, context.col);
    value = value === null ? '' : value;
    var oldValue = String(value) ? String(context.sheet.getValue(context.row, context.col)) : '';
    var strArr = [];
    if (oldValue) {
      oldValue = oldValue.split('\n');
      // @ts-ignore
      $.each(oldValue, function (i, e) {
        strArr.push('<span contentEditable="true" class="gcsj-func-color-text">' + String(e) + '</span>')
      })
    }
    strArr = strArr.length ? strArr : ['<span contentEditable="true" class="gcsj-func-color-text"></span>'];

    var input = GC.Spread.Sheets.CellTypes.Text.prototype.createEditorElement();
    var $input = $(input);
    $input.css('text-align', 'left')
    var that = this;
    // this.input = input;
    if (!AutoJudgeTypeCellType.selectUl || !$('#ss ul')) {
      var ul = document.createElement('ul');
      var $ul = $(ul);
      $ul.input = input;
      $ul.sheet = context.sheet;
      $ul.attr("gcUIElement", "gcEditingInput");
      $ul.on('click', function (event) {
        if (event.target.nodeName == 'LI') {
          var curSpan = $($ul.input).find('span').last();
          var value = curSpan.text();
          var str = '';
          if ($ul.attr('data-type') == 'PARAM') {
            str = '}'
            // } else if ($ul.attr('data-type') == 'INSTRUCT') {
            //   str = '$'
          } else if ($ul.attr('data-type') == 'FUNCTION') {
            str = '#'
          }
          if ($ul.attr('data-str')) {
            curSpan.text(value.slice(0, value.lastIndexOf($ul.attr('data-str'))) + $(event.target).html() + str);
          } else {
            curSpan.text(value + $(event.target).html() + str);
          }
          if ($ul.attr('data-type') == 'INSTRUCT' && $(event.target).attr('data-param')) {
            var paramData = $(event.target).attr('data-param');
            var oldParam = $ul.sheet.getValue($ul.attr('data-row'), 3)
            paramData = oldParam ? oldParam + ',' + paramData : paramData;
            $ul.sheet.setText($ul.attr('data-row'), 3, paramData);
          }
          $ul.css('display', 'none');
        }
      })
      $ul.attr({ 'id': '_selectUl', 'data-row': context.row }).css({ 'position': 'absolute', 'display': 'none' });
      $('#ss').append(ul);
      AutoJudgeTypeCellType.selectUl = $ul;
    } else {
      if (AutoJudgeTypeCellType.selectUl.parent().prop('id') != 'ss') {
        $('#ss').append(AutoJudgeTypeCellType.selectUl.get(0));
      }
      AutoJudgeTypeCellType.selectUl.attr('data-row', context.row);
      AutoJudgeTypeCellType.selectUl.input = input;
      AutoJudgeTypeCellType.selectUl.sheet = context.sheet;
    }
    var baseDom = $('<span class="gcsj-func-color-content">' + strArr.join('') + '</span>');
    $input.html(baseDom);
    setTimeout(function () {
      that.setPos(input);
      if (baseDom.css('height') > $input.parent().parent().css('height')) {
        $input.css('height', baseDom.css('height'));
        $input.parent().parent().css('height', baseDom.css('height'));
      }
    }, 0)
    $input.on('input', function () {
      var oldPos = that.getPos(input);
      var posInfo = that.judgeNodeIndex(input, oldPos);
      clearTimeout(that.searchTimer);
      that.searchTimer = setTimeout(function () {
        AutoJudgeTypeCellType.selectUl.css({ 'display': 'none' });
        var span = $input.find('.gcsj-func-color-text');
        if (span.length) {
          that.setRelateValue(span.eq(posInfo[0]).text(), context.col);
        }
        AutoJudgeTypeCellType.selectUl.css('top', parseInt($input.parent().parent().css('height')) + parseInt($input.parent().parent().css('top')))
      }, 300);
      var text = $input.text();
      $input.html('');
      if (baseDom.find('span').length > 1) {
        var lastspan = baseDom.find('span').last();
        var oldText = baseDom.text();
        lastspan.text(lastspan.text() + text.substr(oldText.length));
      } else {
        baseDom.find('span').last().text(text);
      }
      $input.html(baseDom);
      var first = $input.children().eq(0);
      var height = parseInt(first.css('height'))
      if (parseInt($input.css('height')) < height) {
        $input.css('height', height).parent().parent().css('height', height);
      }
      that.setPos(input, oldPos);
    })
    $input.on('keydown', function (e) {
      if (13 == e.keyCode && e.altKey) {
        // baseDom.append('<span contentEditable="true" class="gcsj-func-color-text">&#8203</span>');
        var pos = that.getPos(input);
        var judgeResult = that.judgeNodeIndex(input, pos);
        var curSpan = $input.find('.gcsj-func-color-text').eq(judgeResult[0]);
        var otigintext = curSpan.text();
        var str = otigintext.slice(judgeResult[1]) ? otigintext.slice(judgeResult[1]) : '';
        var newSpan = $('<span contenteditable="true" class="gcsj-func-color-text">' + str + '</span>');
        newSpan.insertAfter(curSpan);
        curSpan.text(otigintext.slice(0, judgeResult[1]))
        that.setPos($input.find('.gcsj-func-color-text').get(newSpan.index()), 0);
        $input.css('height', baseDom.css('height'));
        $input.parent().parent().css('height', baseDom.css('height'));
      } else if (8 == e.keyCode) {
        var spans = baseDom.find('.gcsj-func-color-text');
        var pos = that.getPos(input);
        var judgeResult = that.judgeNodeIndex(input, pos);
      }
    })
    $input.on('keyup', function (e) {
      if (e.ctrlKey && e.keyCode == "67") {
        document.execCommand("Copy");
      }
    })
    $input.on("paste", function (e) {
      var pastedText;
      if ((window).clipboardData && (window).clipboardData.getData) { // IE
        pastedText = (window ).clipboardData.getData('Text');
      } else {
        pastedText = e.originalEvent.clipboardData.getData('Text');//e.clipboardData.getData('text/plain');
      }
      var selection = window.getSelection();
      if (!selection.rangeCount) return false;
      selection.deleteFromDocument();
      selection.getRangeAt(0).insertNode(document.createTextNode(pastedText));

      e.preventDefault();
    });
    return input;
  };

  getParams() {
    var typeArr = [];
    var codeArr = [];
    var paramTypeArr= [];
    // @ts-ignore
    $.each(paramLists, function (i, e) { // 注意此处的引用！
      var str = e.value ? ':' + e.value : '';
      typeArr.push(e.code + str);
      codeArr.push(e.code);
      paramTypeArr.push(e.type);
    })
    return { typeArr: typeArr, codeArr: codeArr, paramTypeArr: paramTypeArr };
  }
  transData(isInstruct, data) {
    return isInstruct ? data.split('.')[1] : data;
  }


  setRelateValue(value, col) {
    clearTimeout(this.searchTimer);
    var that = this;
    if (value) {
      var result = AutoJudgeTypeCellType.isSim ? this.judgeSimulationType(value, col) : this.judgeType(value, col);
      if (result.needJudge) {
        AutoJudgeTypeCellType.selectUl.attr({ 'data-str': result.str, 'data-type': result.type });
        //@ts-ignore
        var typeArr = AutoJudgeTypeCellType[result.type];
        if (result.type == 'PARAM') {
          typeArr = that.getParams().typeArr;
        }
        var len = typeArr.length;
        var liArr = [], count = 0;
        result.str = result.str.charCodeAt(0) == 8203 ? result.str.substr(1) : result.str;
        if (!result.str) {
          for (var i = 0; i < 10 && i < len; i++) {
            //@ts-ignore
            var str = result.type == "INSTRUCT" ? that['INSTRUCTPARAM'][i] : '';
            liArr.push('<li data-param="' + str + '">' + typeArr[i] + '</li>');
          }
        } else {
          var isInstruct = result.type == "INSTRUCT" || result.type == "REMOTPARAM";
          //@ts-ignore
          
          if(result.type == 'SUBSYS') {
            typeArr.forEach((e) => {
              e.indexOf(result.str) >= 0 && liArr.push('<li data-param="' + e + '">' + e + '</li>')
            })
          } else {
            var index = that.findIndex(typeArr, result.str, 0, typeArr.length, isInstruct);
            if (index >= 0 && that.transData(isInstruct, typeArr[index]).indexOf(result.str) == 0) {
              for (let j = index; j >= 0; j--) {
                if (count < 10 && that.transData(isInstruct, typeArr[j]).indexOf(result.str) == 0) {
                  //@ts-ignore
                  var str = result.type == "INSTRUCT" ? AutoJudgeTypeCellType['INSTRUCTPARAM'][j] : '';
                  liArr.push('<li data-param="' + str + '">' + typeArr[j] + '</li>');
                  count++;
                } else {
                  break;
                }
              }
              if (count < 10) {
                for (var k = index + 1; k < len; k++) {
                  if (count < 10 && that.transData(isInstruct, typeArr[k]).indexOf(result.str) == 0) {
                    //@ts-ignore
                    var str = result.type == "INSTRUCT" ? AutoJudgeTypeCellType['INSTRUCTPARAM'][k] : '';
                    liArr.push('<li data-param="' + str + '">' + typeArr[k] + '</li>');
                    count++;
                  } else {
                    break;
                  }
                }
              }
            }
            // 遥测参数列可填写基本函数
            if(result.type == 'REMOTPARAM') {
              canUseFuncArr.forEach(e => {
                e.indexOf(result.str) == 0 && liArr.unshift('<li data-param="' + str + '">' + e + '</li>')
              })
            }
          }
        }
        if (liArr.length) {
          AutoJudgeTypeCellType.selectUl.html(liArr.join(''));
          AutoJudgeTypeCellType.selectUl.css('display', 'block');
        }
      } else {
        AutoJudgeTypeCellType.selectUl.removeAttr('data-str');
        AutoJudgeTypeCellType.selectUl.removeAttr('data-type');
      }
    }
  }


  judgeType(value, col) {
    var result = {
      type: '',
      needJudge: false,
      str: ''
    }
    if (col == 2) { // 指令列
      var str = value && String(value).trim().replace(/,|，/g, '\n');
      if (str) {
        var strArr = str.split('\n');
        var last = strArr[strArr.length - 1];
        if (last.indexOf('{') == 0) {
          var paramStartFlags = value.match(/\{/g);
          var paramEndFlags = value.match(/\}/g);
          if (paramStartFlags) {
            result.type = 'PARAM';
            result.needJudge = true;
            if (!paramEndFlags || paramStartFlags.length > paramEndFlags.length) {
              var str = value.slice(value.lastIndexOf('{') + 1).trim();
              if (str) {
                result.str = str;
              }
            }
          }
        } else {
          result.type = 'INSTRUCT';
          result.needJudge = true;
          result.str = last;
        }
      }
      return result;
    }
    if (col == 9) { // 分系统列
      var str = value && String(value).trim().replace(/,|，/g, '\n');
      if (str) {
        var strArr = str.split('\n');
        var last = strArr[strArr.length - 1];
        result.type = 'SUBSYS';
        result.needJudge = true;
        result.str = last;
      }
      return result;
    }
    var paramStartFlags = value.match(/\{/g);
    var paramEndFlags = value.match(/\}/g);
    if (paramStartFlags) {
      result.type = 'PARAM';
      result.needJudge = true;
      if (!paramEndFlags || paramStartFlags.length > paramEndFlags.length) {
        var str = value.slice(value.lastIndexOf('{') + 1).trim();
        if (str) {
          result.str = str;
        }
      }
      return result;
    }

    var funcFlags = value.match(/#/g);
    if (funcFlags && funcFlags.length % 2) {
      result.type = 'FUNCTION';
      result.needJudge = true;
      var str = value.slice(value.lastIndexOf('#') + 1).trim();
      if (str) {
        result.str = str;
      }
      return result;
    }

    var str = value.trim().replace(/\+|-|\*|\/|%|==|\[(.+?)\]|\{(.+?)\}|:|~|,|，|!=|&&|\|\||&|\||>>|<<|<|>/g, '\n');
    result.type = 'REMOTPARAM';
    result.needJudge = true;
    if (str) {
      var strArr = str.split('\n');
      var last = strArr[strArr.length - 1];
      if (last) {
        result.str = last;
      }
    }
    return result;
  }

  judgeSimulationType(value, col) {
    var result = {
      type: '',
      needJudge: false,
      str: ''
    }
    if ([1,2,3,4].indexOf(col) > -1) { // 指令列
      var str = value && String(value).trim().replace(/,|，/g, '\n');
      if (str) {
        var strArr = str.split('\n');
        var last = strArr[strArr.length - 1];
        result.type = 'INSTRUCT';
        result.needJudge = true;
        result.str = last;
      }
      return result;
    }

    if (col == 15) { // 分系统列
      var str = value && String(value).trim().replace(/,|，/g, '\n');
      if (str) {
        var strArr = str.split('\n');
        var last = strArr[strArr.length - 1];
        result.type = 'SUBSYS';
        result.needJudge = true;
        result.str = last;
      }
      return result;
    }
    
    var str = value.trim().replace(/\+|-|\*|\/|%|=|\[(.+?)\]|\{(.+?)\}|:|~|,|，/g, '\n');
    result.type = 'REMOTPARAM';
    result.needJudge = true;
    if (str) {
      var strArr = str.split('\n');
      var last = strArr[strArr.length - 1];
      if (last) {
        result.str = last;
      }
    }
    return result;
  }
  activateEditor(editorContext, cellStyle, cellRect, context) {
    var $editor = $(editorContext);
    GC.Spread.Sheets.CellTypes.Base.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
    $editor.css("position", "absolute");
    $editor.attr("gcUIElement", "gcEditingInput");
    return $editor;
  };
  getEditorValue(editorContext, context) {
    var result = [];
    var spanArr = $(editorContext).find('.gcsj-func-color-text');
    // @ts-ignore
    $.each(spanArr, function (index, ele) {
      var tx = $(ele).text();
      if (tx.length && tx[tx.length - 1] == '\n') {
        tx = tx.slice(0, tx.length - 1);
      }
      result.push(tx);
    })
    return result.join('\n');
  }
  updateEditor(editorContext, cellStyle, cellRect, context) {
    if (editorContext) {
      var $editor = $(editorContext);
      $editor.css("width", cellRect.width);
      // $editor.css("height", cellRect.height);
      var editParent = $editor.parent().parent();
      if (parseInt(editParent.css('height')) < parseInt($editor.height())) {
        editParent.css('height', $editor.height());
      } else {
        $editor.css("height", cellRect.height);
      }
      AutoJudgeTypeCellType.selectUl.css({
        left: editParent.css('left'),
        top: (parseInt(String(cellRect.height)) + parseInt(editParent.css('top'))) + 'px',
        width: cellRect.width
      })
    }
    return cellRect
  };
  isReservedKey = function (event, context) {
    if (context.isEditing && (event.keyCode == 40 || event.keyCode == 38)) {
      return true;
    }
    return false;
  };
  deactivateEditor(editorContext, context) {
    if (editorContext) {
      if(!AutoJudgeTypeCellType.isSim) {
        SP.prototype.setNormalBorder(context.sheet, context.row, context.col);
        SP.prototype.checkKeyWordExplain(context.sheet, context.row, context.col, true);
        context.sheet.comments.remove(context.row, context.col);
      } else {
        SP.prototype.checkSimInstructionOrParamOrSubsys(context.sheet, context.row, context.col)
      }
      
    }
    if (AutoJudgeTypeCellType.selectUl) {
      AutoJudgeTypeCellType.selectUl.css('display', 'none');
    }
    GC.Spread.Sheets.CellTypes.Base.prototype.deactivateEditor.call(this, editorContext, context);
  };
}

// class UnblurCellType extends GC.Spread.Sheets.CellTypes.Text { // 自定义blur事件类
//   // static [propName: SPREAD.blurEvents]: (sheet: SPREAD.Worksheet, row: number, col: number, newVal: string, oldValue: string) => void
//   oldValue: string = ''
//   constructor(public callbackName: string, blurCallback: (sheet: SPREAD.Worksheet, row: number, col: number, newVal: string, oldValue: string | undefined) => void, public needJudgeValue: boolean = true) {
//     super()
//     //@ts-ignore
//     if (!UnblurCellType[callbackName]) {
//       //@ts-ignore
//       UnblurCellType[callbackName] = blurCallback
//     }
//   }

//   deactivateEditor(editorContext: HTMLElement, context: any) {
//     if (editorContext) {
//       var that = this;
//       var curValue = $(editorContext).find('span.gcsj-func-color-text').text();
//       if (that.needJudgeValue) {
//         if (curValue != that.oldValue) {
//           //@ts-ignore
//           UnblurCellType[that.callbackName](context.sheet, context.row, context.col, curValue, that.oldValue);
//           that.oldValue = curValue;
//         }
//       } else {
//         //@ts-ignore
//         UnblurCellType[that.callbackName](context.sheet, context.row, context.col, curValue, that.oldValue);
//         that.oldValue = curValue;
//       }
//     }
//     GC.Spread.Sheets.CellTypes.Base.prototype.deactivateEditor.call(this, editorContext, context);
//   };
// }

// class SelectCellType extends GC.Spread.Sheets.CellTypes.Base { // 自定义下拉选择类
//   oldValue: string = '';
//   constructor(public optionsTypeName: string, options: any[], public callback: any = null) {
//     super()
//     //@ts-ignore
//     if (!this[optionsTypeName]) {
//       let arr: string[] = [];
//       //@ts-ignore
//       $.each(options, function (index, ele) {
//         typeof ele == 'string' ? 
//           arr.push('<option value="' + ele + '">' + ele + '</option>') :
//           arr.push('<option value="' + ele.value + '">' + ele.label + '</option>')
//       })
//       //@ts-ignore
//       this[optionsTypeName] = arr;
//     }
//   }
//   createEditorElement = function (context: any) {
//     var selectDom = document.createElement("select");
//     //@ts-ignore
//     $(selectDom).html(this[this.optionsTypeName].join(''));
//     return selectDom;
//   };
//   activateEditor(editorContext: HTMLEmbedElement, cellStyle: GC.Spread.Sheets.Style, cellRect: GC.Spread.Sheets.Rect, context: any) {
//     GC.Spread.Sheets.CellTypes.Base.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
//     return editorContext;
//   };
//   deactivateEditor(editorContext: HTMLElement, context: any) {
//     if (editorContext) {
//       var $editor = $(editorContext);
//       var curValue = $editor.val() && $editor.val().trim();
//       context.oldValue = this.oldValue;
//       context.newValue = curValue;
//     }
//     if(this.callback && typeof this.callback == 'function') {
//       this.callback(curValue, context)
//     }
//     GC.Spread.Sheets.CellTypes.Base.prototype.deactivateEditor.call(this, editorContext, context);
//   };
//   setEditorValue(editorContext: HTMLElement, value: string, context: any) {
//     $(editorContext).val(value);
//     this.oldValue = value;
//   };
//   getEditorValue(editorContext: HTMLElement, context: any) {
//     return $(editorContext).val();
//   }
//   updateEditor(editorContext: HTMLElement, cellStyle: GC.Spread.Sheets.Style, cellRect: GC.Spread.Sheets.Rect, context: any): GC.Spread.Sheets.Rect {
//     if (editorContext) {
//       var $editor = $(editorContext);
//       $editor.css("width", cellRect.width);
//       $editor.css("height", cellRect.height);
//     }
//     return cellRect;
//   };
//   isReservedKey(event: any, context: any) {
//     if (context.isEditing && (event.keyCode == 40 || event.keyCode == 38)) {
//       return true;
//     }
//     return false;
//   };
// }



// class EMPTYCELLTYPE extends GC.Spread.Sheets.CellTypes.Base {
//   paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, w: number, h: number, style: GC.Spread.Sheets.Style, context?: any) {
//     GC.Spread.Sheets.CellTypes.Base.prototype.paint.apply(this, [ctx, ' ', x, y, w, h, style, context]);
//   }
// }

// class TEXTCELLTYPE extends GC.Spread.Sheets.CellTypes.Text {
//   paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, w: number, h: number, style: GC.Spread.Sheets.Style, context?: any) {
//     //@ts-ignore
//     value = value instanceof Date ? new Date(value).Format('yyyy/MM/dd HH:mm:ss') : value
//     GC.Spread.Sheets.CellTypes.Base.prototype.paint.apply(this, [ctx, value, x, y, w, h, style, context]);
//   }
  
// }


// export class LAYERCELLTYPE extends GC.Spread.Sheets.CellTypes.Base {
//   showValue: string = ''
//   oldValue: string = ''
//   constructor(public showLayerFunc: (context: any) => any, row: number, col: number) {
//     super();
//   }
//   //@ts-ignore
//   createEditorElement(context: any) {
//     typeof this.showLayerFunc == 'function' && this.showLayerFunc(context);
//     return null;
//   };
//   paint(ctx: CanvasRenderingContext2D, value: any, x: number, y: number, w: number, h: number, style: GC.Spread.Sheets.Style, context?: any) {
//     GC.Spread.Sheets.CellTypes.Base.prototype.paint.apply(this, [ctx, this.showValue, x, y, w, h, style, context]);
//   };
//   // activateEditor (editorContext, cellStyle, cellRect, context) {
//   //   GC.Spread.Sheets.CellTypes.Base.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
//   //   return editorContext;
//   // };
//   // LAYERCELLTYPE.prototype.deactivateEditor = function (editorContext, context) {
//   //   if (editorContext) {
//   //     // var $editor = $(editorContext);
//   //     // var curValue = $editor.val() && $editor.val().trim();
//   //     // context.oldValue = this.oldValue;
//   //     // context.newValue = curValue;
//   //   }
//   //   GC.Spread.Sheets.CellTypes.Base.prototype.deactivateEditor.call(this, editorContext, context);
//   // };
//   // setEditorValue (editorContext: any, value: string, context: any) {
//   //   $(editorContext).val(value);
//   //   this.oldValue = value;
//   // };
//   // getEditorValue (editorContext: any, context: any) {
//   //   return $(editorContext).val();
//   // };
//   // updateEditor (editorContext: any, cellStyle, cellRect, context) {
//   //   if (editorContext) {
//   //     var $editor = $(editorContext);
//   //     $editor.css("width", cellRect.width);
//   //     $editor.css("height", cellRect.height);
//   //   }
//   // };
// }


// export class SELFButton extends GC.Spread.Sheets.CellTypes.Button {
//   bind(type: string, callback: (param: { row: number, col: number, sheet: SPREAD.Worksheet }) => void): void {
//     if (type == GC.Spread.Sheets.Events.ButtonClicked) {
//       this.processMouseUp = function (hitInfo: SPREAD.selfHitInfo): boolean {
//         callback({
//           row: hitInfo.row,
//           col: hitInfo.col,
//           sheet: hitInfo.sheet as SPREAD.Worksheet
//         })
//         return true;
//       };
//     }
//   }
// }


export const judgeObj = {
  rules: {
    empty: /^发送[\s\S]*后(，|,)判读[\s\S]*$|^发送[\s\S]*$|^判读[\s\S]*$/,
    async: /^发送[\s\S]*后(，|,)不等待回令(，|,)判读[\s\S]*$|^发送[\s\S]*后(，|,)不等待回令$|^不等待回令(，|,)判读[\s\S]*$/,
    if: /^若[\s\S]*满足(，|,)执行\d+-\d+步骤&/,
    else: /^若[\s\S]*不满足(，|,)执行\d+-\d+步骤$/,
    while: /^若[\s\S]*满足(，|,)循环执行\d+-\d+步骤$/,
    call: /^调用用例[\s\S]*/,
    end: /^条件语句或者循环语句结束$/
  },
  needNot: ['PAUSE', 'NOTIFY', 'TODO'],
  keyWordsText: {
    'END': '条件语句或者循环语句结束',
    'END_IF': '条件语句结束',
    'END_WHILE': '循环语句结束',
    'SCRIPT': '执行自定义脚本',
    'RESET': '重置全局变量'
  }
}

function parseColWidth(width, widthArr= []) { // 将width铺满
  let sum = 0;
  widthArr.forEach((ele) => {
    sum += ele[1];
  })
  widthArr.forEach((ele, index) => {
    widthArr[index][1] = parseInt(String(ele[1] / sum * width));
  })
}

function initSpread(option) {
  return new SP(option);
}

export default {
  initSpread,
  SP,
  parseColWidth,
  judgeObj: judgeObj,
}